Subject: Re: bug#15880: Compute C declarations for DEFSYMs automatically.

From: Eli Zaretskii <[email-masked]>
Date: Thu, 14 Nov 2013 05:47:43 +0200

> From: Stefan Monnier <[email-masked]>
> Cc: [email-masked],  [email-masked]
> Date: Wed, 13 Nov 2013 17:00:36 -0500
> 
> >> I'm wondering about one issue, tho: this creates a "big single file
> >> dependency", so addition/removal of a DEFSYM somewhere causes
> >> recompilation of all files.
> > How is that different from changing variables and functions exposed to
> > Lisp, and the dependency on globals.h?
> 
> Fundamentally, it's no different, but I think that in practice it's
> different for one reason: the type of a Qfoo variable is always
> Lisp_Object, so there's never a need to recompile because that
> object changed.  So the cases where recompilation is warranted are
> less frequent.

Recompilation of C files is so fast nowadays that this kind of
optimization gains very little, but can potentially cause waste of
developers' time, whereby they will sometimes need to debug problems
due to the fact that we did not recompile.

So I think this would be a step backward, to the era when the
dependency on lisp.h was suppressed for similar reasons.